; OPT_Res	0	   ; RichMasm assumes this code needs no resources - delete if rsrc.rc is needed


.nolist
include \masm32\include\masm32rt.inc

.686
.xmm
include \masm32\macros\timers.asm			
LOOP_COUNT	= 10000


.data
TEST_COUNT dd	200000

.code

;######################################
option prologue:none
option epilogue:none
align 16
Axrand proc STDCALL dwRange:DWORD
	if 1
	mov eax, Initial	; get the seed
	imul eax, 127	; randomise
	add eax, 127
	bswap eax	; we need the high order bits
	; mov eax, edx	; multiply Initial
	mov Initial, eax	; save for next round
	mul dword ptr [esp+4]	; with range
	mov eax, edx	; return random number
;	mov edx, Initial	; get the seed
;	imul edx, 127	; randomise
;	add edx, 127
;	bswap edx	; we need the high order bits
;	mov eax, edx	; multiply Initial
;	mov Initial, edx	; save for next round
;	mul dword ptr [esp+4]	; with range
;	mov eax, edx	; return random number
	cheat = 0
	if cheat
	if 1
		movzx eax, ax
	else
		shr edx, 16
		not edx
		mov ax, dx
	endif
	endif
	elseif 0
		mov eax, Initial
		push eax
		mul dword ptr [esp+8]
		mov eax, edx
		pop edx
		;xor edx,dword ptr [esp]	; for making results clearness, I have remove this, due to this line is compile-time dependent.
		imul edx, 127	; 12347
		add edx, 127
		bswap edx
		mov Initial,edx
	else
		mov eax,Initial
		mul dword ptr [esp+4]
		mov eax,edx
		mov edx,Initial
		;xor edx,dword ptr [esp]	; for making results clearness, I have remove this, due to this line is compile-time dependent.
		imul edx,12347
		add edx,17
		bswap edx
		mov Initial,edx
	endif
		ret 4
	.data
		align 4
		Initial dd "RAND"
	.code
Axrand endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
;######################################


start:
.data?
align 4
argc	dd	?
argv	dd	?
env	dd	?
.code

; get an count of testing DWORDs and bytes from command line.
; if number of args is not 2 (exe name and number itself), or number is 0
; then leave the default value (200,000) loops of test
push eax
mov edx,esp
invoke crt___getmainargs,offset argc,offset argv,offset env,0,edx

mov edi,CTXT("rand_dword.bin")

mov eax,argc
mov ecx,argv
cmp eax,2
jnz @F
mov edx,[ecx+4]

invoke crt_atol,edx
test eax,eax
jz @F
mov TEST_COUNT,eax
@@:

; allocate the memory for the output buffer, size in DWORDs, used for the bytes, too
mov eax,TEST_COUNT
shl eax,2
invoke crt_malloc,eax
xchg esi,eax
test esi,esi
jz @doneerror


; write dwords file
invoke crt_fopen,edi,CTXT("w+b")
xchg ebx,eax
test ebx,ebx
jz @errorreport

mov edi,esi

mov ecx,TEST_COUNT
@@:
invoke Axrand,-1
stosd
loop @B

invoke crt_fwrite,esi,TEST_COUNT,4,ebx

invoke crt_fclose,ebx


; write #X bytes files


add esp,-1024

xor ebp,ebp

@writebytes:
mov edi,esp
mov Initial,"RAND"	; reset the seed to the initial value
invoke crt_sprintf,edi,CTXT("rand_#%ubyte.bin"),ebp
invoke crt_fopen,edi,CTXT("w+b")
xchg ebx,eax
test ebx,ebx
jz @errorreport


mov edi,esi
mov ecx,TEST_COUNT
@@:
invoke Axrand,-1
push ecx
lea ecx,[ebp*8]	; shift non-tested bytes
shr eax,cl
pop ecx
stosb
loop @B
invoke crt_fwrite,esi,TEST_COUNT,1,ebx
invoke crt_fclose,ebx

inc ebp
cmp ebp,4
jb @writebytes

invoke crt_printf,CTXT("Generation of the files was done")

@done:
xor edi,edi
@doneerror:
invoke crt_exit,edi

@errorreport:
invoke crt_printf,CTXT("Error while creating of the ""%s"" file"),edi
jmp @doneerror


end start
